{*
* 2007-2012 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2012 PrestaShop SA
*  @version  Release: $Revision: 6594 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$lang_iso}">
	<head>
		<title>{$meta_title|escape:'htmlall':'UTF-8'}</title>
{if isset($meta_description) AND $meta_description}
		<meta name="description" content="{$meta_description|escape:html:'UTF-8'}" />
{/if}
{if isset($meta_keywords) AND $meta_keywords}
		<meta name="keywords" content="{$meta_keywords|escape:html:'UTF-8'}" />
{/if}
		<meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" />
		<meta http-equiv="content-language" content="{$meta_language}" />
		<meta name="generator" content="PrestaShop" />
		<meta name="robots" content="{if isset($nobots)}no{/if}index,{if isset($nofollow) && $nofollow}no{/if}follow" />
		<link rel="icon" type="image/vnd.microsoft.icon" href="{$favicon_url}?{$img_update_time}" />
		<link rel="shortcut icon" type="image/x-icon" href="{$favicon_url}?{$img_update_time}" />
		<script type="text/javascript">
			var baseDir = '{$content_dir}';
			var baseUri = '{$base_uri}';
			var static_token = '{$static_token}';
			var token = '{$token}';
			var priceDisplayPrecision = {$priceDisplayPrecision*$currency->decimals};
			var priceDisplayMethod = {$priceDisplay};
			var roundMode = {$roundMode};
		</script>
{if isset($css_files)}
	{foreach from=$css_files key=css_uri item=media}
	<link href="{$css_uri}" rel="stylesheet" type="text/css" media="{$media}" />
	{/foreach}
{/if}
<link href='http://fonts.googleapis.com/css?family=Oswald:300' rel='stylesheet' type='text/css'>
{if isset($js_files)}
	{foreach from=$js_files item=js_uri}
	<script type="text/javascript" src="{$js_uri}"></script>
	{/foreach}
{/if}
		{$HOOK_HEADER}
	</head>
	
	<body {if isset($page_name)}id="{$page_name|escape:'htmlall':'UTF-8'}"{/if} class="{if $hide_left_column}hide-left-column{/if} {if $hide_right_column}hide-right-column{/if}">
	{if !$content_only}
		{if isset($restricted_country_mode) && $restricted_country_mode}
		<div id="restricted-country">
			<p>{l s='You cannot place a new order from your country.'} <span class="bold">{$geolocation_country}</span></p>
		</div>
		{/if}
		<div id="page" class="container_9 clearfix" {if $tpl_params->width}style="width:{$tpl_params->width}"{/if}>

			<!-- Header -->
			<div id="header" class="grid_9 alpha omega">
					<div id="top-header">
						{$HOOK_TOP}
					</div>
					<!-------logo-------->
					{if $page_name == "index"}
						<h1 class="Ot-logo">
							<a href="{$link->getPageLink('index.php')}" title="{$shop_name|escape:'htmlall':'UTF-8'}">
								<span>{$shop_name|escape:'htmlall':'UTF-8'}</span>
							</a>
						</h1>
					{else}
						<h2 class="Ot-logo">
							<a href="{$link->getPageLink('index.php')}" title="{$shop_name|escape:'htmlall':'UTF-8'}">
								<span>{$shop_name|escape:'htmlall':'UTF-8'}</span>
							</a>
						</h2>
					{/if}
					<!--------------End logo---------->
			</div>
			
			<!-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
			<div class="clear"></div>
			<div id="ot-menuBar">
				{$HOOK_MENUBAR}
			</div>
			
			<!-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
			{if $page_name=='index'}
				<div class="clear"></div>
				<div id="ot-banner-slideshow" >
					<div class="ot-slideshow">
						<div class="ot-slideshow-i">
							<div class="ot-slideshow-ii">
								{$HOOK_BANNER}
							</div>
						</div>
					</div>					
				</div>
				<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
				<div class="clear"></div>
				<div id="topbox">
					<div class="topbox-i">
						<div class="topbox-ii">
							{$HOOK_TOPBOX}
						</div>
					</div>
				</div>
				<div class="clear"></div>
				<div id="ot-top-content">
					<div class="ot-top-content-i">
						<div class="ot-top-content-ii">
							<div class="ot-top-content-iii">
								{$HOOK_TOPCONTENT}
							</div>
						</div>
					</div>
				</div>
			{/if}
			<!-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
			<div id="columns" class="bg-border-left-top {$tpl_params->column_layout} grid_9 alpha omega clearfix {if $page_name =='index'}ot-index{else}ot-subpage{/if}"  >
				<div class="bg-border-right-top">
				<div class="bg-center-top">
				<!-- Right -->
				{if $tpl_params->column_layout == "contentRight"}
				<div id="right_column" class="column grid_2 omega" >
						{$HOOK_RIGHT_COLUMN}
				</div>
				{/if}
				<!-- Left -->
				{if $tpl_params->column_layout != "contentRight"}
					<div id="left_column" class="column grid_2 alpha" >
						{$HOOK_LEFT_COLUMN}
					</div>
				{/if}
				<!-- Center -->
				<div id="center_column" class=" grid_5">
	{/if}